<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoadDing()">
    <div class="container">
        <p class="h3 text-left mt-5 "> Order Detai!!! </p>
        <div class="form-group col-12">
            <!-- <hr class="mt-5 mb-5" /> -->
        </div>

        <div class="form-group">
            <label>Order Code(mã đơn hàng):</label>
            <input class="form-control" id="inp-odercode" placeholder="...">
        </div>
        <div class="form-group">
            <label>Cỡ Combo:</label>
            <select id="select-size" class="form-control">
                <option value="NOT_SELECT_COMBO"> Chọn cỡ Combo (Combo size)</option>
                <option value="S"> Nhỏ</option>
                <option value="M"> Vừa</option>
                <option value="L"> Lớn</option>
            </select>
        </div>
        <div class="form-group">
            <label>Đường kính Pizza</label>
            <input class="form-control" id="inp-duong-kinh" placeholder="...">
        </div>
        <div class="form-group">
            <label>Sườn nướng(miếng)</label>
            <input class="form-control" id="inp-suong-nuong">
        </div>
        <div class="form-group">
            <label>Đồ uống</label>
            <select class="form-control" id="select-drink">
                <option value="NOT_SELECT_DRINK">Chọn đồ uống</option>
            </select>
        </div>
        <div class="form-group">
            <label>Số lượng nước uống</label>
            <input class="form-control" id="number-select">
        </div>
        <div class="form-group">
            <label>Voucher ID</label>
            <input class="form-control" id="inp-voucherid">
        </div>
        <div class="form-group">
            <label>Loại pizza</label>
            <select id="select-pizza" class="form-control">
                <option value="NOT_SELECT_PIZZA"> Chọn loại pizza </option>
                <option value="Seafood"> Hải sản</option>
                <option value="Hawaii"> Ha wai </option>
                <option value="Bacon"> Thịt hun khói </option>
            </select>
        </div>
        <div class="form-group">
            <label>Salad</label>
            <input class="form-control" id="inp-salad">
        </div>
        <div class="form-group">
            <label>Thành tiền</label>
            <input class="form-control" id="inp-prices">
        </div>
        <div class="form-group">
            <label>Giảm giá</label>
            <input class="form-control" id="inp-giam-gia">
        </div>
        <div class="form-group">
            <label>Họ và tên</label>
            <input class="form-control" id="inp-fullname">
        </div>
        <div class="form-group">
            <label>Email</label>
            <input class="form-control" id="inp-email">
        </div>
        <div class="form-group">
            <label>Số điện thoại</label>
            <input class="form-control" id="inp-mobile">
        </div>
        <div class="form-group">
            <label>Địa chỉ</label>
            <input class="form-control" id="inp-adress">
        </div>
        <div class="form-group">
            <label>Lời nhắn</label>
            <input class="form-control" id="inp-message">
        </div>
        <div class="form-group">
            <label> Trạng thái đơn hàng</label>
            <input class="form-control" id="inp-status">
        </div>
        <div class="form-group">
            <label>Ngày tạo đơn</label>
            <input class="form-control" id="inp-creat-order">
        </div>
        <div class="form-group">
            <label>Ngày cập nhật</label>
            <input class="form-control" id="inp-update">
        </div>
        <div class="btn-group">
            <button onclick="onBtnConfirmClick()" class="btn btn-success">Confirm</button>
            <button onclick="onBtnCancelClick()" class="btn btn-danger">Cancel</button>
        </div>
    </div>
</body>
<script>
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
    const gREQUEST_DELETE_SUCCESS = 204; // status 204 - Xóa thành công
    const gBASE_URL_Order = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    const gBASE_URL_Drinks = "http://203.171.20.210:8080/devcamp-pizza365/drinks";
    //
    function onPageLoadDing() {
        var vUrlString = window.location.href;
        console.log(vUrlString);
        //
        var vUrl = new URL(vUrlString);
        // truy vấn 
        gId = vUrl.searchParams.get("id");
        gOrder = vUrl.searchParams.get("orderCode");
        // validate
        const vFORM_LIST_VIEW = "indexListView.html";
        if (gId == null || gId == "") {
            window.location.href = vFORM_LIST_VIEW;
            alert("Không có ID của đơn hàng ");
        }
        else if (gOrder == null || gOrder == "") {
            window.location.href = vFORM_LIST_VIEW;
            alert("Không có orderCode");
        }
        console.log("ID : " + gId);
        console.log("Mã đơn hàng : " + gOrder);
        //
        loadDataSelectDrinks();
        // bước 3 gọi API
        var vXmlHttpGetAllOrder = new XMLHttpRequest();
        callAPIOrderData(gOrder, vXmlHttpGetAllOrder);
        vXmlHttpGetAllOrder.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    showDataOrderForm(vXmlHttpGetAllOrder);
                }
            }
    }
    // hàm nút Nút confirm click
    function onBtnConfirmClick() {
        var vUrlString = window.location.href;
        console.log(vUrlString);
        //
        var vUrl = new URL(vUrlString);
        // truy vấn 
        var vId = vUrl.searchParams.get("id");
        //
        console.log(vId);
        var vObjectRequest = {
            trangThai: "confirmed",
            //3 trạng thái: open, confirmed, cancel
        };
        var vXmlHttpUpdateOrder = new XMLHttpRequest();
        callAPIConfirmClick(vXmlHttpUpdateOrder, vObjectRequest, vId);
        vXmlHttpUpdateOrder.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(vXmlHttpUpdateOrder.responseText);
                    showDataConfirmClick(vXmlHttpUpdateOrder);
                    
                }
            }
    }
    // hàm nút Cancel click
    function onBtnCancelClick()
    {
        var vUrlString = window.location.href;
        console.log(vUrlString);
        //
        var vUrl = new URL(vUrlString);
        // truy vấn 
        var vId = vUrl.searchParams.get("id");
        //
        var vObjectRequest = {
            trangThai: "cancel",
            //3 trạng thái: open, confirmed, cancel
        };
        var vXmlHttpUpdateOrder = new XMLHttpRequest();
        callAPIConfirmClick(vXmlHttpUpdateOrder, vObjectRequest, vId);
        vXmlHttpUpdateOrder.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(vXmlHttpUpdateOrder.responseText);
                    showDataConfirmClick(vXmlHttpUpdateOrder);
                    
                }
            }
    }
    // hàm sự kiện gọi API order
    function callAPIOrderData(paramOrder, paramXmlHttp) {
        paramXmlHttp.open("GET", gBASE_URL_Order + "/" + paramOrder, true);
        paramXmlHttp.send();
    }
    // hàm sự kiện API confirm click
    function callAPIConfirmClick(paramXmlHttp, paramConfirm, paramId) {

        paramXmlHttp.open("PUT", gBASE_URL_Order + "/" + paramId);
        paramXmlHttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        paramXmlHttp.send(JSON.stringify(paramConfirm));
    }
    // hàm tạo select cho đồ uống
    function loadDataSelectDrinks() {
        var vXhttp = new XMLHttpRequest();
        vXhttp.open("GET", gBASE_URL_Drinks, true);
        vXhttp.send();
        vXhttp.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(vXhttp.responseText); //ghi response text ra console.log
                    showDataSelectDrinks(vXhttp);
                }
            };
    }
    // hàm hiện thị select Đồ uống
    function showDataSelectDrinks(paramXmlHttp) {
        var vPerson = JSON.parse(paramXmlHttp.responseText);
        console.log(vPerson);
        // truy xuất 
        var vElementSelect = document.getElementById("select-drink");
        for (var bI = 0; bI < vPerson.length; bI++) {
            var vDrinksSelect = document.createElement("option");
            vDrinksSelect.value = vPerson[bI].maUongNuoc;
            vDrinksSelect.text = vPerson[bI].tenNuocUong;
            vElementSelect.appendChild(vDrinksSelect);
        }
    }
    // hàm show data confirm click
    function showDataConfirmClick(paramXmlHttp) {
        var vPerson = JSON.parse(paramXmlHttp.responseText);
        console.log(vPerson);
        //
        var vStatus = document.getElementById("inp-status");
        vStatus.value = vPerson.trangThai;
        console.log("Trạng thái được update là : " + vPerson.trangThai);
    }
    // hàm show data vào form onPageloadding
    function showDataOrderForm(paramXmlHttp) {
        var vPerson = JSON.parse(paramXmlHttp.responseText);
        //

        var vOrderCode = document.getElementById("inp-odercode");
        var vCombo = document.getElementById("select-size");
        var vDuongKinhPizza = document.getElementById("inp-duong-kinh");
        var vSuongNuong = document.getElementById("inp-suong-nuong");
        var vDrinks = document.getElementById("select-drink");
        var vSLNuocUong = document.getElementById("number-select");
        var vVoucherID = document.getElementById("inp-voucherid");
        var vPizzaType = document.getElementById("select-pizza");
        var vSalad = document.getElementById("inp-salad");
        var vThanhTien = document.getElementById("inp-prices");
        var vDiscount = document.getElementById("inp-giam-gia");
        var vFullName = document.getElementById("inp-fullname");
        var vEmail = document.getElementById("inp-email");
        var vSoDienThoai = document.getElementById("inp-mobile");
        var vDiaChi = document.getElementById("inp-adress");
        var vLoiNhan = document.getElementById("inp-message");
        var vStatus = document.getElementById("inp-status");
        var vTaoDonHang = document.getElementById("inp-creat-order");
        var vUpdate = document.getElementById("inp-update");
        // gán giá trị cho từng form 
        vOrderCode.value = vPerson.orderCode;
        vCombo.value = vPerson.kichCo;
        vDuongKinhPizza.value = vPerson.duongKinh;
        vSuongNuong.value = vPerson.suon;
        vDrinks.value = vPerson.idLoaiNuocUong;
        vSLNuocUong.value = vPerson.soLuongNuoc;
        vVoucherID.value = vPerson.idVourcher;
        vPizzaType.value = vPerson.loaiPizza;
        vSalad.value = vPerson.salad;
        vThanhTien.value = vPerson.thanhTien;
        vDiscount.value = vPerson.giamGia;
        vFullName.value = vPerson.hoTen;
        vEmail.value = vPerson.email;
        vSoDienThoai.value = vPerson.soDienThoai;
        vDiaChi.value = vPerson.diaChi;
        vLoiNhan.value = vPerson.loiNhan;
        vStatus.value = vPerson.trangThai;
        vTaoDonHang.value = vPerson.ngayTao;
        vUpdate.value = vPerson.ngayCapNhat;
    }


</script>

</html>